#ifndef WIRECELL_IGEOMETRY
#define WIRECELL_IGEOMETRY

#include "WireCellUtil/IComponent.h"
#include "WireCellIface/IWire.h"
#include "WireCellIface/ICell.h"
#include "WireCellIface/IWireSummary.h"
#include "WireCellIface/ITiling.h"

namespace WireCell {

    /** An interface bundling together all major geometry interfaces.
     */
    class IGeometry : virtual public IComponent<IGeometry> {
    public:

	virtual ~IGeometry() {}

	virtual IWire::vector wires() = 0;
	virtual ICell::vector cells() = 0;
	virtual ITiling::pointer tiling() = 0;
	virtual IWireSummary::pointer wire_summary() = 0;

    };


}

#endif
